﻿using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class Controller : MonoBehaviour
{
    public Note Instance { get; set; }

    public List<Controller> enables,
                            disables;

    private float time = 0f;

    private readonly float minAlpha = 0.3f;
    private readonly float maxAlpha = 0.7f;
    
    // Update is called once per frame
    void Update()
    {
        if (transform.parent.gameObject.name == "Deactives")
        {
            time += Time.deltaTime * 3;

            foreach (Image img in GetComponentsInChildren<Image>())
            {
                Color tmp = img.color;
                tmp.a = 0f;
                img.color = tmp + new Color(0, 0, 0,
                    (maxAlpha + minAlpha) / 2
                    + Mathf.Cos(time * 4) * (maxAlpha - minAlpha) / 2);
            }
        }
    }

    public void Deactivate(Transform deactives)
    {
        Instance.Activated = false;

        foreach (Image img in GetComponentsInChildren<Image>())
        {
            Color tmp = img.color;
            tmp.a = 0f;
            img.color = tmp + new Color(0, 0, 0, minAlpha);
        }

        transform.SetParent(deactives);
        disables.Add(this);
        enables.Remove(this);
    }

    public float EndPosition(float ScrollSpeed)
    {
        return transform.position.x +
            (Instance.EndTiming - Instance.StartTiming) * ScrollSpeed;
    }
}